Bug 784730

Summary: Enabled event sources cause initial resource component start to time out
Product: [Other] RHQ Project Reporter: Larry O'Leary <loleary>
Component: AgentAssignee: RHQ Project Maintainer <rhq-maint>
Status: CLOSED CURRENTRELEASE QA Contact: Mike Foley <mfoley>
Severity: high Docs Contact:
Priority: high    
Version: 4.2CC: bkramer, hrupp, jshaughn, skondkar, spinder
Target Milestone: ---   
Target Release: JON 3.0.1   
Hardware: All   
OS: All   
Whiteboard:
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: 773435 Environment:
Last Closed: 2013-09-03 11:14:15 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Bug Depends On: 773435    
Bug Blocks: 760116    

Description Larry O'Leary 2012-01-25 18:26:52 EST
Backport fix d1a4410a78bfbed7baa8b65b71abea0315a3fea0 to JON 3.0.1

+++ This bug was initially created as a clone of Bug #773435 +++

Ever wonder why it takes a while to get your first batch of log file
events...

During component start plugins that support event sources create the
logfile event pollers for enabled event sources.  Unfortunately the
poller creation is blocked because it is trying to use to the
eventManager to access Sigar.  This is because the initial
component start takes place during container initialization, which
holds a write lock and does not yet allow access to the managers. This
results in a 60 second timeout, waiting for the lock. Which in turn
(quietly) fails the component start.  Eventually the component will
be started again, when the pc for any reason tries to interact
with the resource container.  But the interrupted component start and
poller creation is not good, and can potentially introduce issues
depending on how well the plugin (and our poller code) is written.

--- Additional comment from jshaughn@redhat.com on 2012-01-11 16:57:00 EST ---

commit d1a4410a78bfbed7baa8b65b71abea0315a3fea0

lazily access sigar on the first polling, which happens after container
initialization.


Test Notes
Perhaps not super-easy to test but with debug logging on the agent and
and an enabled event source (enable the built in event source for the
RHQ Server resource) you should see no related messages of any severity
for the component startup (at agent startup time). Also, the log
event generation should work as expected, generating an event for each 
server log entry (assuming the default settings)

--- Additional comment from jshaughn@redhat.com on 2012-01-18 12:29:16 EST ---

*** Bug 782796 has been marked as a duplicate of this bug. ***
Comment 1 Jay Shaughnessy 2012-01-31 15:21:51 EST
release/jon3.0.x cherry pick:

commit d44638c22a94b4997fd3a5af9f27b642bed97ef0

[Bug 773435 - Enabled event sources cause initial resource component start to time out]
lazily access sigar on the first polling, which happens after container
initialization.

Conflicts:

    modules/core/plugin-api/src/main/java/org/rhq/core/pluginapi/event/log/LogFileEventPoller.java
Comment 2 Simeon Pinder 2012-02-02 14:34:55 EST
Moving to ON_QA as 3.0.1 RC2 is available from here:

https://brewweb.devel.redhat.com//buildinfo?buildID=197202
Comment 3 Sunil Kondkar 2012-02-16 07:04:37 EST
Verified on Version: 3.0.1.GA RC4 (Build Number: dd8a001:c5270fb)

Verified by enabling debug logging on the agent and enabling event source for the
RHQ Server resource. Also, verified that event logs are generated for each 
server log entry.
Comment 4 Heiko W. Rupp 2013-09-03 11:14:15 EDT
Bulk closing of old issues in VERIFIED state.